#include <stdio.h>
#include "compilerApi.h"

#define TIMER_CLEAR    0
#define TIMER_START    1
#define TIMER_STOP     2
#define TIMER_ELAPSED  3
#define REGISTER       4

#define BEFORE  0
#define AFTER   1

enum FLAG {off, on};
FLAG in_main_program;
FLAG in_procedure;
int tabnumber=0;
void doFullType(SgType *t);
void doSymbAttribs(SgSymbol *s);
void doRoutineHeader(SgStatement *s);
void doSymb(SgSymbol *s);
void register_var();
void timer_start(),timer_clear(),timer_stop(),timer_elapsed();


// Insert a C function call statement
void 

InsertFCallNode(int event_type, SgStatement *s, int how)
{

  SgSymbol *symb ;
         
  switch (event_type) {
    case TIMER_CLEAR: symb = new SgVariableSymb("timer_clear");
                        break;
    case TIMER_START: symb = new SgVariableSymb("timer_start");
                        break;
    case TIMER_STOP:  symb = new SgVariableSymb("timer_stop");
                        break;
    case TIMER_ELAPSED:symb = new SgVariableSymb("timer_elapsed"); 
                         break;
    case REGISTER : symb = new SgVariableSymb("REGISTER");
      break;
    

 }


  SgCallStmt *func;
  SgValueExp *ev;
  
  /*if (evet_type == REGISTER){
    func = new SgCallStmt(*symb);
    

  }*/
  

  func = new SgCallStmt(*symb);
  ev = new SgValueExp(event_type);
  func->addArg(*ev);
  delete(ev);

  switch (how) {
    case BEFORE:
         s->insertStmtBefore(*func,*(s->controlParent()));
         break;
    case AFTER:
         s->insertStmtAfter(*func,*(s->controlParent()));
         break;
  }
}

void puttab(int number)
{
  for(int i=0; i<number; i++)
    printf("  ");
}

void action(SgStatement * s)
{
  SgDeclarationStatement *decl;
  SgProgHedrStmt *spg;
  SgCallStmt *cstmt;
    
  puttab(tabnumber);
  printf("id:%4d   variant:%4d linenum:%4d\n", s->id(), s->variant(),
   s->lineNumber());
  if ((isSgExecutableStatement(s))&&(s->variant() != CONTROL_END)){
    InsertFCallNode(TIMER_STOP, s , BEFORE);
  }
  
  else if (spg = isSgProgHedrStmt(s)){
      SgSymbol *symb;
      SgExpression   *st;
      SgArrayType *atype;
      
      
      for(symb = spg ->firstSymbolInScope();symb;symb = symb->next())
      {
        if (spg->isSymbolNameInScope(symb->identifier())){
            printf("Inside scope varriant = %d name = %s ",
	    symb->variant(),symb->identifier());
            doSymbAttribs(symb);
	    
   	    if (symb->type())
   	    {
            	    
	      if (symb->type()->variant() == T_KIND){
	         int kvar = (symb->type()->thetype->entry.kind_decl.kindexp)->variant;
		 printf("expvar = %d\n",kvar);
                 int kinval = (symb->type()->thetype->entry.kind_decl.kindexp)->entry.list_s.item->entry.literal.value->entry.ival;
		 printf("kindval = %d\n",kinval);
                 printf("basetype_variant = %d\n",
			symb->type()->thetype->entry.kind_decl.base_type->variant)	;
		
         		 
	      }
              if (atype = isSgArrayType(symb->type())){
		
              printf("TYPE = %d BASE_TYPE=%d\n",symb->type()->variant(),
                     symb->type()->baseType()->variant()  );
              printf("DIMENSION = %d\n",atype->dimension());
	      }
	      
	      
	    }
	    
		
	 }
		 
      }
      
  }
 

}

void transform(SgStatement * s) 
{
  int i=0;

  int org_numberOfChildren1=s->numberOfChildrenList1();
   int org_numberOfChildren2= s->numberOfChildrenList2();
  int org_numberOfChildren = org_numberOfChildren1 + org_numberOfChildren2;
   SgStatement * * children = new SgStatement * [org_numberOfChildren];
   SgStatement *st;
   SgStatement *line;
   
   for (i=0; i<org_numberOfChildren1; i++)
	children[i]=s->childList1(i);

  for (; i<org_numberOfChildren; i++)
     children[i]=s->childList2(i-org_numberOfChildren1);

   for (i=0; i<org_numberOfChildren; i++){
     st =  children[i];
     if ((st -> variant() != FORALL_CONSTRUCT_STMT)&&
         (st -> variant() != INTERFACE_STMT))
     {
       action(st);
       doRoutineHeader(st);
       transform(st);
     }
     
   }
      
   delete [] children;
   return;
   
}

SgStatement *find_first_exec_stmt(SgStatement *s)
{
  int i;
  
   int nlchilds = s->numberOfChildrenList1();
 
   printf("NCHILDS = %d\n",nlchilds);
   
   for(i=0;i<nlchilds;i++)
     if (!isSgExecutableStatement(s->childList1(i)))
	 break;

   printf("I FOUND FIRST EXECSTMTM = %d line = %d\n",s->childList1(i)->variant(),
	  s->childList1(i)->lineNumber());
   
   return (s->childList1(i));
}

int give_type_symbol(SgType *vtype)
{
  int variant_type = vtype->variant();
  int var_type;
  
  switch(variant_type){
           
     case T_CHAR: var_type = 0; break;
     case T_INT: var_type = 1; break;
     case T_FLOAT: var_type = 2; break;
     case T_DOUBLE : var_type = 4; break;
     case T_BOOL: var_type = 5; break;
     case T_ARRAY:  var_type = give_type_symbol(vtype->baseType());break;
     case T_KIND:
	int base_type = 
           vtype->thetype->entry.kind_decl.base_type->variant;
        int kind_val = (vtype->thetype->entry.kind_decl.kindexp)->entry.               list_s.item->entry.literal.value->entry.ival; 
        switch(base_type){
	case T_INT:
	  switch(kind_val){
	  case 1:var_type = 1;break; /* Byte */
	  case 2:var_type = 7;break; /* Short */
	  case 4:var_type = 1;break; /* Integer */
	  case 8:var_type = 3;break; /* Long */
	  }
	  	  
	  break;
	case T_FLOAT:  
	  switch(kind_val){
	  case 4:var_type = 2;break; /* Float */
	  case 8:var_type = 4;break; /* Double */
	  }
	  
	  break;
	}
	break;
  }

  return var_type;
 
}


int symb_ndims(SgSymbol *symb)

{
  int vtype =  symb->type()->variant();
  SgArrayType *atype;
  int ndims;
    
  switch(vtype){
  case T_ARRAY: if (atype = isSgArrayType(symb->type()))
                   ndims = atype->dimension();
  break;
  
  default:ndims = 0;break;
  }
  return ndims;
  
}

  
void insert_register_and_config_params(SgStatement *s)
{

    SgProgHedrStmt *    prog;    
    SgProcHedrStmt *    subr;  
    SgProsHedrStmt *    pros;
    SgFuncHedrStmt *    func;     
    SgSymbol *symb;
    SgVariableSymb *fsymb,*shape_symb;
    SgStatement    *    festmt;
    int var_type;
    int ndims,scope,var_id;
    char *name ;
    SgValueExp *sve;
    SgCallStmt *scstmt;
    SgVarRefExp *e1;
    SgVariableSymb *ptsymb;
    SgFunctionCallExp *fce;
                      
    if(subr = isSgProcHedrStmt (s)){
	printf("symbol:%s", (subr->name()).identifier());
        printf(" which is a subroutine.\n");
        /* find first executable stmt in current scope */
        festmt = find_first_exec_stmt(subr);

        for(symb = subr ->firstSymbolInScope();symb;symb = symb->next())
        {
           if (subr->isSymbolNameInScope(symb->identifier())){
	      fsymb = new SgVariableSymb("register_var");
	      scstmt = new SgCallStmt(*fsymb);
	      
              /* add var_type parameters to register_var subroutine */
	      var_type = give_type_symbol(symb->type());
              sve = new SgValueExp(var_type);
	      scstmt->addArg(*sve);
              
              /* add variable id = parameter var_id */	
              ptsymb = new SgVariableSymb("var_id");
	      e1 = new SgVarRefExp(*ptsymb);
	      scstmt->addArg(*e1);

              /* add variable itself = var parameter */
              e1 = new SgVarRefExp(*symb);
	      scstmt->addArg(*e1);
             
              /* add variable literal name = name parameter */
              char *ts = (char *)malloc(strlen(symb->identifier())+3);
	      strcpy(&ts[1],symb->identifier());
	      ts[0] = '\'';
	      ts[strlen(symb->identifier())+1] = '\'';
              ts[strlen(symb->identifier())+2] = '\0';
              	      
	      sve = new SgValueExp(ts);
	      scstmt->addArg(*sve);
              
              /* add var_ndims parameter */
	      ndims = symb_ndims(symb);
              sve = new SgValueExp(ndims);
	      scstmt->addArg(*sve);

              /*prepare shape(A) call fucntion for dim_info parameter*/
              /* Here we are trying to calculate the shape of var */
              shape_symb = new SgVariableSymb("shape");
	      fce   = new SgFunctionCallExp(*shape_symb );
	      sve = new SgValueExp(symb->identifier());
              fce -> addArg(*sve);
	      
              /* Add dim_info parameter  */
              scstmt->addArg(*fce);

              festmt->insertStmtAfter(*scstmt,*(festmt->controlParent()));
           }
	}
    }
}

              
	      
              	





void doRoutineHeader(SgStatement *s){
SgProgHedrStmt *    prog;    
SgProcHedrStmt *    subr;  
SgProsHedrStmt *    pros;
SgFuncHedrStmt *    func;     
int i;
SgSymbol *sy;

  if(subr = isSgProcHedrStmt (s)){
	printf("symbol:%s", (subr->name()).identifier());
        printf(" which is a subroutine.\n");
        printf("parameter list:\n");
	for(i = 0; i < subr->numberOfParameters(); i++){
		sy = subr->parameter(i);
		printf("parameter(%d):", i); doSymb(sy);
                //printf(" of type: "); doFullType(sy->type());
		doSymbAttribs(sy); 
		printf("\n"); 
		}
        //insert_register_and_config_params(s);
	
	}
   else if(pros = isSgProsHedrStmt (s)){
        printf("symbol:%s", (pros->name()).identifier());
        printf(" which is a process.\n");
        printf("parameter list:\n");
        for(i = 0; i < pros->numberOfParameters(); i++){
                sy = pros->parameter(i);
                printf("parameter(%d):", i); doSymb(sy);
                printf(" of type: "); doFullType(sy->type());
                doSymbAttribs(sy);
                printf("\n");
                }
        }
   else if(func = isSgFuncHedrStmt (s)){
	printf("symbol:%s", (func->name()).identifier());
        printf("which is a function of type ");
	doFullType((func->name()).type());
        printf("\n");
        printf("parameter list:\n");
	for(i = 0; i < func->numberOfParameters(); i++){
		sy = func->parameter(i);
		printf("parameter(%d):", i); doSymb(sy); 
                printf(" of type: "); doFullType(sy->type()); 
		doSymbAttribs(sy); 
		printf("\n"); 
		}
	}
  
    else if(prog = isSgProgHedrStmt (s)){
      
        //printf("symbol:%s", (prog->name()).identifier());
        printf("which is program  of type ");
	//doFullType((prog->name()).type());
        printf("\n");
        printf("parameter list:\n");
    }


}

void doSymbAttribs(SgSymbol *s){
	int i;

      	if(s->attributes()){
	    i = s->attributes();
	    printf(" attributes =( ");
              if(i & ALLOCATABLE_BIT ){ printf(" allocatable,"); }
              if(i & DIMENSION_BIT  ){ printf(" dim,"); }
              if(i & EXTERNAL_BIT ){ printf(" extern,"); }
              if(i & IN_BIT  ){ printf(" in,"); }
              if(i & INOUT_BIT  ){ printf(" inout,"); }
              if(i & INTRINSIC_BIT  ){ printf(" intrinsic,"); }
              if(i & OPTIONAL_BIT  ){ printf(" optional,"); }
              if(i & OUT_BIT  ){ printf(" out,"); }
              if(i & PARAMETER_BIT  ){ printf(" parameter,"); }
              if(i & POINTER_BIT ){ printf(" pointer,"); }
              if(i & PRIVATE_BIT ){ printf(" private,"); }
              if(i & PUBLIC_BIT  ){ printf(" public,"); }
              if(i & SAVE_BIT  ){ printf(" save,"); }
              if(i & SEQUENCE_BIT  ){ printf(" seq,"); }
              if(i & RECURSIVE_BIT  ){ printf(" recur,"); }
              if(i & TARGET_BIT  ){ printf(" target,"); }
	    printf(")");
	}
}

// given a type, traverse it and generate full infomration
void doFullType(SgType *t){
   SgArrayType *arrayt;
   SgPointerType *ptr;
   SgReferenceType *ref; // only for C++
   SgDerivedType *deriv;
   SgDescriptType *descr; // only for C and C++
   SgDerivedCollectionType *col; // only for pC++
   SgType *tmp;
   int i,n,j;
   SgSubscriptExp *sexp;
   SgExpression *sval;
   SgExprListExp *el;
     
   if(arrayt = isSgArrayType(t)){
        printf("dimension("); 
	n = arrayt->dimension();

	if (el = isSgExprListExp(arrayt->getDimList()))
	  
	    for(j=0;j<el->length();j++){
                if (sexp = isSgSubscriptExp(el->elem(j)))
		{
		  sval = sexp->lbound();
                  if (sval -> isInteger())
	            printf("%d: ",sval->valueInteger());
                  else if(isSgValueExp(sval))
                    printf("YES HRRR\n");
		  
	          sval = sexp->ubound();
                  if (isSgConstExp(sval)) 
                    printf("YA YA..\n");
		  
                  if (sval -> isInteger())
	            printf("%d: ",sval->valueInteger());
                  else {
                    printf("exp_var = %d\n",sval->variant());
		    doSymb(sval->symbol());
		                      		    
		  }
		  
          		  

                  sval = sexp->step();
                  if (sval -> isInteger())
	            printf("%d ",sval->valueInteger());
                  else if(isSgValueExp(sval))
                    printf("YES HRRR\n");   
                }
     	  	if(i < n-1) printf(", ");
	    }
	printf(") ");
   }
   	
   else{
	switch(t->variant()){
           case T_INT:     printf("integer "); break;
           case T_FLOAT:   printf("real "); break;
           case T_DOUBLE:  printf("double precision "); break;
           case T_CHAR:    printf("character "); break;
           case T_BOOL:    printf("boolean "); break;
           case T_STRING:  printf("string "); break;
           case T_RECORD:  printf("record.. more later "); break;
           case T_UNKNOWN: printf("unknown "); break;
           case T_COMPLEX: printf("complex "); break;
           case LOCAL:
           case INPUT: 
           case OUTPUT:
           case IO: 
               printf("do these later\n");
 	       break;
	   }
   }
   if(t->hasBaseType()){
        tmp = t->baseType();
        if (tmp != NULL) {
	  printf("of "); 
	  doFullType(tmp);
          }
	}

} 

void traverse_symbols(SgFile *file)
{
  SgSymbol *sl;
  
  sl = file->firstSymbol();
  for(;sl;sl=sl->next()){
    
    doSymbAttribs(sl);
    printf("natts = %d\n",sl->numberOfAttributes());
    
  }
}



void doSymb(SgSymbol *s){
    printf("SYMB[%d]:%s:var=%d\n",s->id(),s->identifier(),s->variant());
}

int main(int argc, char **argv){

  SgFile * file;
  SgProject * project = new SgProject("test", argc, argv);

  for (int i=0; i< project->numberOfFiles(); i++) {

    file = &(project->file(i));
    
    SgStatement * s = file->firstStatement();

    transform(s);
    // save a copy of the input file, if you like.
   file->saveDepFile("debug.dep");

  };

  return 0;
}







